
      program rename_netCDF_attribute

      implicit none

      include 'netcdf.inc'

c     Variables:
      integer narg,varsize,oldsize,newsize,filesize,nc_status
      integer nc_id,var_id
      character*30 varname,oldname,newname
      character*120 filename


c     Functions:
      integer str_len,iargc

      narg = iargc()
      if (narg .ne. 4) go to 999

      call getarg(1,filename)
      call getarg(2,varname)
      call getarg(3,oldname)
      call getarg(4,newname)

      filesize = str_len(filename)
      varsize  = str_len(varname)
      oldsize  = str_len(oldname)
      newsize  = str_len(newname)

c     Open netCDF file:
      nc_status = NF_OPEN(filename(1:filesize), NF_WRITE, nc_id)
      if (nc_status .ne. NF_NOERR) call handle_err(nc_status,1)

c     Get variable ID:
      nc_status = NF_INQ_VARID(nc_id, varname(1:varsize), var_id)
      if (nc_status .ne. NF_NOERR) call handle_err(nc_status,21)

c     Enter define mode?
      if (newsize .gt. oldsize) then
         nc_status = NF_REDEF(nc_id)
         if (nc_status .ne. NF_NOERR) call handle_err(nc_status,11)
      end if

c     Rename:
      nc_status = NF_RENAME_ATT(nc_id, var_id,
     >                          oldname(1:oldsize), newname(1:newsize))
      if (nc_status .ne. NF_NOERR) call handle_err(nc_status,22)

      if (newsize .gt. oldsize) then
c        Leave define mode:
         nc_status = NF_ENDDEF(nc_id)
         if (nc_status .ne. NF_NOERR) call handle_err(nc_status,31)
      end if

c     Close file:
      nc_status = NF_CLOSE(nc_id)
      if (nc_status .ne. NF_NOERR) call handle_err(nc_status,91)


      go to 1000

 999  write(*,*)
      write(*,*)'Error in the program "rename_netCDF_attribute".'
      write(*,*)' SYNTAX ERROR.'
      write(*,*)'  Syntax:'
      write(*,*)' nc_rename_attr <file> <var name> <old name> ',
     >          '<new name>'
      write(*,*)'  where'
      write(*,*)'   <file>      is the name of a netCDF file'
      write(*,*)'   <var name>  is the existing name of a variable on ',
     >          '<file>'
      write(*,*)'   <old name>  is the existing name of an attribute ',
     >          'of <var name> on <file>'
      write(*,*)'   <new name>  is the new attribute name that will ',
     >          'replace <old name>'
      write(*,*)'Terminates.'
      write(*,*)

 1000 end
